% //********************************************************************************************
% // A Financial accelerator model
% //
% //
% //  ******* Non Linear Version *********
% //
% // 
% //********************************************************************************************


clear all; close all; clc

dynare ParamValueFA
dynare model_FA
close all;

nvars  = char('yexp', 'iexp', 'cexp','rrealexp','pipexp', 'Rexp', 'qexp', 'zexp','nwexp', 'rrexp', 'Welfexp', 'lexp', 'wexp');

% --------------------------
% Plot IRFs - Ramsey Policy
% --------------------------

    warning off

    vnamesd = {'Output ($\hat{y}_{t}$)','Investment ($\hat{i}_{t}$)','Consumption ($\hat{c}_{t}$)',...
                    'Real Interest rate','Inflation ($\hat{\pi_{t}}$)','Interest rate ($\hat{R}_{t}$)',...
                    'Price of capital ($\hat{q}_{t}$)','Rental rate of capital ($\hat{z}_{t}$)',...
                    'Net worth ($\hat{n}_{t}$)','Risk premium ($\widehat{\check{r}}_{t}$)','Welfare',...
                    'labor ($\hat{l}_{t}$)','wage ($\hat{w}_{t}$)'};

    nshock = char('_eps_gamma','_eps_sig','_eps_a','_eps_techno','_eps_eps');  
    nnames = char('Net Worth', 'Uncertainty','Credit Supply Shock','Techno Shock','monetary');

    for ss = 1 : 1;
        nirfd1 = [];
        nshock1 = cellstr(nshock(ss,:));
        nshocks = char(nshock1);

        for i = 1 : size(nvars,1)
            nvars1 = cellstr(nvars(i,:));
            nvarss = char(nvars1);
            nvarss = ['oo_.forecast.Mean.',nvarss];
            nirfd = eval(nvarss);
%             nirfd = eval([nvarss,nshocks]);
            nirfd1 = [nirfd1 nirfd];
        end

        hor = 30;
        figure('name',nnames(ss,:))
        for vv = 1 : length(nvars)
             subplot(4,4,vv)
             zz = nirfd1(1:hor,vv);
             zz0 = plot(0:1:hor-1,zz);
             set(zz0(1),'LineWidth',1,'color',[0.7 0.2 0.4])
             set(gca,'Xlim',[0 hor],'XlimMode','manual','fontsize',5)
             t1 = title(vnamesd{vv});
             set(t1,'fontsize',8,'interpreter','latex')
             set(gcf,'Units','inches','PaperUnits','inches')
             set(gcf,'PaperPosition',[.25 .25 7.77 11.19]);
            fn = sprintf('plotirf%d',i);
            set(get(gca,'XLabel'),'String','Periods after shock','fontname','times','fontsize',5)
            set(get(gca,'YLabel'),'String','Percent deviation','fontname','times','fontsize',5)
        end
        
           save_graph = 0;
            nshocks = ['figTR',nshock(ss,1:7)];
            fn = ['D:\TRAVAIL\celine\Financial_accelerator\OMP\model_simul\Ramsey\zzfigures\',nshocks];
            if save_graph; set(gcf,'PaperPositionMode','auto'); print(gcf,'-dpdf', fn); end

    end
    
