% -----------------------------------
%  A Financial accelerator model
%
%       with ZLB?
% ------ Non Linear Version -----
% -----------------------------------



var     lambda, c, R, pip, rreal, lh, w, y, l, k, s, we, z, Welf, UU,
        lomegatilde, clag,
        Fome, Fnome, omegatilde, SIG, muG, ffome, deltau, deltauu, adji, adjii, 
        nw, i, ktilde, b, xx, q, rk, rr, LAM, v, ce, SIGp, muGp, 
        cexp, Rexp, pipexp, rrealexp, wexp, yexp, lexp, zexp, nwexp, iexp, bexp, qexp, rkexp, rrexp, Welfexp,
        gammat,  sigome, a, techno;


varexo      eps_gamma ; //eps_techno 
varexo_det  eps_em;

parameters  bc sigmac betaa alpha Omega alphap tetap mup gammap muW mu varrho rhoi ap ay eps_tax delta d kapai sigmal sigmaWbar
        eps_taxw muww alphaw tetaw gammaw Q1wbar Q2wbar Wstarbar lomebar muGpbar SEome rotem ppbar sigmaGamma UUbar Welfbar
        lambdabar cbar Rbar pipbar rrealbar lhbar wbar piwbar ybar lbar kbar sbar webar zbar Q1bar Q2bar Pstarbar Fomebar abar 
        Fnomebar omebar SIGbar muGbar SIGpbar ffomebar deltaubar deltauubar adjibar  adjiibar nwbar ibar ubar gbar chilbar 
        ktildebar bbar xxbar qbar rkbar rrbar LAMbar vbar cebar  gammabar deltatild rhoGamma rhoPref rhoEm rhoTechno prefbar embar technobar
        rhoSIG rhoA ;

load_params_and_steady_state(ParamMatrixFA);

model;


    // ---- Household's Preferences
    UU         = ((sigmac/(sigmac-1))*(c-bc*clag)^((sigmac-1)/sigmac) - (1/(1+sigmal))*lh^(1+sigmal));
    Welf       = UU + betaa*Welf(1);
    lambda     = (c-bc*c(-1))^(-1/sigmac) - betaa*bc*(c(1)-bc*c)^(-1/sigmac);
    (1/R)      = betaa*(lambda(1)/lambda)*(1/(pip(1)));
    rreal      = R/pip(1);
    clag       = c(-1);

    // ---- Wage Setting
    chilbar*lh^(sigmal) = lambda*w;


    // ---- Production Sector
    y          = techno*((l)^(1-alpha))*(k^(alpha));
    l          = lh^(Omega);
    w          = s*Omega*(1-alpha)*(y/lh);
    we         = s*(1-Omega)*(1-alpha)*y;
    z          = s*alpha*(y/k);

    // ---- Price Setting
    1 - rotem*(pip-1)*pip + rotem*betaa*((c(1)^(-1/sigmac))/(c^(-1/sigmac)))*((pip(1)-1)*pip(1)*y(1)/y) = (1-s)*tetap;

    // ---- Financial Accelerator: Definitions
    lomegatilde = log(omegatilde);
    Fome        = normcdf(lomegatilde,muW,sigmaWbar);
    ffome       = exp(-0.5 * ((log(omegatilde) - muW)/sigmaWbar)^2) / (omegatilde * sqrt(2*3.14) * sigmaWbar);
    Fnome       = 1 - exp(muW+sigome*sigome/2)*normcdf(((muW - lomegatilde)/sigome)+sigome,0,1);
    SIG         = omegatilde*(1-Fome) + Fnome;
    muG         = mu*Fnome;
    SIGp        = 1 - Fome;

    muGp        = mu*omegatilde*ffome;
    deltau      = delta;
    deltauu     = 0;
    adji        = (kapai/2)*(i/i(-1) - 1)^2;
    adjii       = (kapai)*(i/i(-1))*(i/i(-1) - 1);
    b           = q(-1)*ktilde(-1) - nw(-1);
    xx          = q(-1)*ktilde(-1)/nw(-1);
    rr          = rk(1)/rreal;

    // ---- Financial Accelerator Contract
    LAM(1)     = (rk(1)/rreal)*(1 - SIG(1) + LAM(1)*(SIG(1) - muG(1)));
    SIGp       = LAM*(SIGp - muGp);
    a*(xx - 1) = (rk/rreal(-1))*xx*(SIG - muG);


    // ---- Financial Intermediate Sector
    rk         = (z + (1-deltau)*q)/q(-1);
    nw         = gammat*v + we;
    v          = rk*q(-1)*ktilde(-1) - rreal(-1)*q(-1)*ktilde(-1) + rreal(-1)*nw(-1) - muG*rk*q(-1)*ktilde(-1);
    ce         = (1-gammat)*varrho*v;

    // ---- Capital Producer Sector
    ktilde     = (1-deltau)*ktilde(-1) + (1-adji)*i;
    1/q        = 1 - adji - adjii + betaa*(q(1)/q)*(lambda(1)/lambda)*pip(1)*adjii(1)*(i(1)/i);
    k          = ktilde(-1);

    // ---- Resource Constraint & Monetary Policy
    y          = c + i + gbar + ce + muG*rk*q(-1)*ktilde(-1) + y*(rotem/2)*(pip-1)^2;
    //(R)/(Rbar)  = exp(eps_em)*((((R(-1))/(Rbar))^(rhoi))*((pip/pipbar)^((1-rhoi)*ap))*((y/ybar)^((1-rhoi)*ay)));

    (R)/(Rbar) = ((((R(-1))/(Rbar))^(rhoi))*((pip/pipbar)^((1-rhoi)*ap))*((y/ybar)^((1-rhoi)*ay))) ;

   
    // ---- Shocks    
    (gammat/gammabar) - ((gammat(-1)/gammabar)^rhoGamma)*exp(eps_gamma);
    //gammat = gammabar;
    //(techno/technobar) - ((techno(-1)/technobar)^rhoTechno)*exp(eps_techno);
    techno  = technobar;
    sigome  = sigmaWbar;
    a       = abar;


    // ---- Exponential values
    c	=	exp(cexp);
    R	=	exp(Rexp);
    pip	=	exp(pipexp);
    rreal = exp(rrealexp);
    w	=	exp(wexp);
    y	=	exp(yexp);
    l	=	exp(lexp);
    z	=	exp(zexp);
    nw	=	exp(nwexp);
    i	=	exp(iexp);
    b	=	exp(bexp);
    q	=	exp(qexp);
    rk	=	exp(rkexp);
    rr	=	exp(rrexp);
    Welf = exp(Welfexp);
end;



initval; 
UU          = UUbar;
Welf        = Welfbar;
lambda      = lambdabar;
c           = cbar;
clag        = cbar;
R           = Rbar;
pip         = pipbar;
rreal       = rrealbar;
lh          = lhbar;
w           = wbar;
y           = ybar;
l           = lbar;
k           = kbar;
s           = sbar;
we          = webar;
z           = zbar;
Fome        = Fomebar;
Fnome       = Fnomebar;
omegatilde	= omebar;
SIG         = SIGbar;
SIGp        = SIGpbar;
muG         = muGbar;
muGp        = muGpbar;
ffome       = ffomebar;
deltau      = deltaubar;
deltauu     = deltauubar;
adji        = adjibar;
adjii       = adjiibar;
nw          = nwbar;
i           = ibar;
ktilde      = ktildebar;
b           = bbar;
xx          = xxbar;
q           = qbar;
rk          = rkbar;
rr          = rrbar;
LAM         = LAMbar;
v           = vbar;
ce          = cebar;
gammat      = gammabar;
techno      = technobar;
sigome      = sigmaWbar;
a           = abar;

cexp        = log(cbar);
Rexp        = log(Rbar);
pipexp      = log(pipbar);
rrealexp    = log(rrealbar);
wexp        = log(wbar);
yexp        = log(ybar);
lexp        = log(lbar);
zexp        = log(zbar);
nwexp       = log(nwbar);
iexp        = log(ibar);
bexp        = log(bbar);
qexp        = log(qbar);
rkexp       = log(rkbar);
rrexp       = log(rrbar);
Welfexp       = log(Welfbar);

end;



steady(solve_algo=2);

shocks;
    var eps_gamma = 0.1^2; 
    //var eps_gamma = 0; 
    //var eps_techno =  0.001^2; 

    var eps_em; 
    //periods 1:1 2:2 3:3 4:4 5:5 6:6 7:7 8:8 9:9 10:10 11:11 12:12 13:13;
    //values  0.000616082	0.000718570	0.000625440	0.000485449	0.000358274	0.000261125	0.000193572	0.000149558	0.000122515	0.000107101	0.000099462	0.000096985	0.000097937	;
    //values  0.00616082	0.00718570	0.00625440	0.00485449	0.00358274	0.00261125	0.00193572	0.00149558	0.00122515	0.00107101	0.00099462	0.00096985	0.00097937	;
    //values 0	0	0	0	0	0	0	0	0	0	0	0	0;
    
    periods 1:1;
    values  0;

end;


steady;


resid(1);
check;
//options_.pruning = 1;
stoch_simul(dr_algo=0, ar=0, nocorr, order=2,  nograph, drop=0);
forecast(periods=130);




